//-------------------------------------------------------------------------//
// Events								   //
// for Nee! Pack							   //
//-------------------------------------------------------------------------//
//		 DONT EVER THINK OF CHANGING THIS SCRIPT CODE		   //
//-------------------------------------------------------------------------//

function onClientMessage(%client, %msg)
{
	if(%client)
	{
		$lastClientMessage = %client;
	}
	if(String::findSubStr(%msg, "flag") != -1)
	{
		NeePack::onFlagMessage(%client, %msg);
	}
	if(String::findSubStr(%msg, "Station") != -1)
	{
		NeePack::onStationMessage(%client, %msg);
	}
	else
	{
		NeePack::MuteMessages(%client, %msg);
	}
}

function NeePack::onStationMessage(%client, %msg)
{
	if(string::findSubStr(%msg, "Station Access On") != -1)
	{
		NeeFavs::EnterStation();
		return Mute;
	}
	if(string::findSubStr(%msg, "Station Access Off") != -1)
	{
		NeeFavs::LeaveStation();
		return mute;
	}
}

function NeePack::onFlagMessage(%client, %msg)
{
	%position = String::findSubStr(%msg, "took the") - 1;
	if(%position > 0)
	{
		$FlagTaker = String::getSubStr(%msg, 0, %position);
	}
	if(String::findSubStr(%msg, "Your team has the") != -1)
	{
		$Enemy = $FlagTaker;
		Control::SetValue("Flag_Enemy_Text", " <B1,2:neepack\\enemy.bmp><f1> " @ $Enemy);
		remoteBP(2048, "<jc><f2>" @ $FlagTaker @ " <f0>took the enemy flag.", 2);
		if($Enemy = "You")
		{
			if(getItemCount("Heavy Armor"))
			{
				Schedule::Add("Say(1, \"Cover me! I am in Heavy Armor!~wcover\");", 4, coverme);
			}
		}
	}
	else if(String::findSubStr(%msg, "Your team's flag has been taken.") != -1)
	{
		$Friendly = $FlagTaker;
		Control::SetValue("Flag_Friendly_Text", " <B1,2:neepack\\friendly.bmp><f1> " @ $Friendly);
		remoteBP(2048, "<jc><f2>" @ $FlagTaker @ " <f0>took your flag.", 2);
	}
	else if(string::findsubstr(%msg, "Your team captured the") != -1)
	{
		$Enemy = "<f0>home";
		Control::SetValue("Flag_Enemy_Text", " <B1,2:neepack\\enemy.bmp><f1> " @ $Enemy);
		remoteBP(2048, "<jc>Your team captured the flag", 2);
	}
	else if(string::findsubstr(%msg, "Your team's flag was captured.") != -1)
	{
		$Friendly = "<f0>home";
		Control::SetValue("Flag_Friendly_Text", " <B1,2:neepack\\friendly.bmp><f1> " @ $Friendly);
		remoteBP(2048, "<jc>Your flag was captured", 2);
    	}
	else if(String::findSubStr(%msg, "Your flag was returned to base.") != -1)
	{
		$Friendly = "<f0>home";
		Control::SetValue("Flag_Friendly_Text", " <B1,2:neepack\\friendly.bmp><f1> " @ $Friendly);
		remoteBP(2048, "<jc>Your flag was <f2>returned<f0> to base.", 2);
	}
	
	else if(String::findSubStr(%msg, "flag was returned to base.") != -1)
	{
		$Enemy = "<f0>home";
		Control::SetValue("Flag_Enemy_Text", " <B1,2:neepack\\enemy.bmp><f1> " @ $Enemy);
		remoteBP(2048, "<jc>The enemy flag was <f2>returned<f0> to base.", 2);
	}
	else if(String::findSubStr(%msg, "was dropped") != -1)
	{
		if(String::findSubStr(%msg, "your flag was dropped") != -1)
		{
			Control::SetValue("Flag_Friendly_Text", " <b1,2:neepack\\friendly.bmp> <f2>dropped");
			remoteBP(2048, "<jc>Your flag was <f2>dropped<f0> in the field.", 2);
		}
		else
		{
			Schedule::Cancel(coverme);
			Control::SetValue("Flag_Enemy_Text", " <b1,2:neepack\\enemy.bmp> <f2>dropped");
			remoteBP(2048, "<jc>The enemy flag was <f2>dropped<f0> in the field.", 2);
		}
	}
}

function NeePack::MuteMessages(%client, %msg)
{
	if(String::findSubStr(%msg, "Command Access") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "Resupply") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "Auto-Repair") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "Unit not powered") != -1)
	{
		Say(1, "Our Generator is destroyed!~wneedrep");
		return mute;
	}
	else if(String::findSubStr(%msg, "Ressuply") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "Unit is disabled") != -1)
	{
		Say(1, "Our Stations need repairs!~wneedrep");
		return mute;
	}
	else if(String::findSubStr(%msg, "SOLD") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "you couldn't buy") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "Shield") != -1)
	{
		remoteBP(2048, "<jc>Shieldpack Message: <f1>" @ %msg, 1);
		return mute;
	}
	else if(String::findSubStr(%msg, "deployed") != -1)
	{
		remoteBP(2048, "<jc>Deploy Message: <f1>" @ %msg, 3);
		return mute;
	}
	else if(String::findSubStr(%msg, "Repair done") != -1)
	{
		return mute;
	}
	else if(String::findSubStr(%msg, "Repairing") != -1)
	{
		return mute;
	}
}

function onClientChangeTeam(%client, %team)
{
	%myid = getManagerID();
	if(%client == %myid)
	{
		// Flag location
		%flag = $Friendly;
		$Friendly = $Enemy;
		$Enemy = %flag;
	}
}

function onTeamAdd(%team, %name)
{
	%teamId = %team - 1;
	$Team[%teamId] = %name;         
	echo("Added new Team: Team no: " @%teamId @" = " @%name);
}

function remoteMissionChangeNotify(%serverManagerId, %nextMission)
{
	if(%serverManagerId == 2048)
	{
		$Friendly = "home";
		$Enemy = "home";
		echo("Server mission complete - changing to mission: ", %nextMission);
		echo("Flushing Texture Cache");
		flushTextureCache();
		schedule("purgeResources(true);", 3);
 	}
}

function PlayGui::OnOpen()
{
	$GrinderPrefs::PlayGui = true;
	FlagTracker::Create();
}

function PlayGui::OnClose()
{
	$GrinderPrefs::PlayGui = false;
}

function onConnection(%message)
{
	echo("Connection ", %message);
	$dataFinished = false;
	if(%message == "Accepted")
	{
		resetSimTime();
		//execute the custom script
		if ($PCFG::Script != "")
		{
			exec($PCFG::Script);
		}
		resetPlayDelegate();
		remoteEval(2048, "SetCLInfo", $PCFG::SkinBase, $PCFG::RealName, $PCFG::EMail, $PCFG::Tribe, $PCFG::URL, $PCFG::Info, $pref::autoWaypoint, $pref::noEnterInvStation, $pref::messageMask);
		if ($Pref::PlayGameMode == "JOIN")
		{
			cursorOn(MainWindow);
			GuiLoadContentCtrl(MainWindow, "gui\\Loading.gui");
			renderCanvas(MainWindow);
		}
		$SimGame::TimeScale = 1; // Fix for Demo Bug
		ReticleCompass::CreateCheck();
	}
	else if(%message == "Rejected")
	{
		Quickstart();
		$errorString = "Connection to server rejected:\n" @ $errorString;
		GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
		schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
	}
	else
	{
	//startMainMenuScreen();
		Quickstart();

		if(%message == "Dropped")
		{
	        	if($errorString == "")
			{
				$errorString = "Connection to server lost:\nServer went down.";
			}
			else
			{
				$errorString = "Connection to server lost:\n" @ $errorString;
			}

			GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
			schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		}
		else if(%message == "TimedOut")
		{
			$errorString = "Connection to server timed out.";
			GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
			schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		}
	}
}

function RecordingsGui::onClose()
{
	$SimGame::TimeScale = 1; // Fix for Demo Bug
}

function onExit()
{
	if($Enable[FlagTracker])
	{
		FlagTracker::Destroy();
	}
	if($Enable[ReticleCompass])
	{
		ReticleCompass::Delete();
	}
	if(isObject(playGui))
	{
		storeObject(playGui, "config\\play.gui");
	}
	saveActionMap("config\\config.cs", "actionMap.sae", "playMap.sae", "pdaMap.sae");
	$pref::VideoFullScreen = isFullScreenMode(MainWindow);
	checkMasterTranslation();
	echo("Exporting Preferences.............");
	export("pref::*", "config\\ClientPrefs.cs", false);
	export("Server::*", "config\\ServerPrefs.cs", false);
	export("pref::lastMission", "config\\ServerPrefs.cs", true);
	BanList::export("config\\banlist.cs");
	if($Enable[NeeFa])
	{
		export("$NeeFavs::Selected", "config\\NeeFavPrefs.nee.cs", false);
	}
}