//-------------------------------------------------------------------------//
// Miscellaneous Scripts						   //
// Nee! Pack								   //
//-------------------------------------------------------------------------//

function Jump::Start()
{
	Jump::Continue();
}

function Jump::Continue()
{
	postAction(2048, IDACTION_MOVEUP, 1);
	Schedule::Add("Jump::Continue();", 0.05);
}

function Jump::Stop()
{
	Schedule::Cancel("Jump::Continue();");
}

function Throw::Grenade()
{
	%gren = getItemCount("Grenade");
	if(%gren > 0)
	{
		remoteEval(2048, throwItem, getItemType("Grenade"), 100);
	}
	else
	{
		remoteBP(2048, "<jc>You don't have any <f2>Grenades<f0> left.", 2);
	}
}

function Throw::Mine()
{
	%mine = getItemCount("Mine");
	if(%mine > 0)
	{
		remoteEval(2048, throwItem, getItemType("Mine"), 100);
	}
	else
	{
		remoteBP(2048, "<jc>You don't have any <f2>Mines<f0> left.", 2);
	}
}

function Throw::All()
{
	Schedule::Cancel(throwall);
	%grens = getItemCount("Grenade");
	if(%grens = 0)
	{
		remoteBP(2048, "<jc>ALL Grenades thrown!", 1);
		return;
	}
	if(%grens > 0)
	{
		remoteEval(2048, throwItem, getItemType("Grenade"), 100);
	}
	Schedule::Add("Throw::All();", 0.5, throwall);
}

if($Enable[KoNTaunts]) // Knights of Nee!
{

function Nee()
{
	Say(0, "Nee!~wnee");
}

function Noo()
{
	Say(0, "Noo!~wnoo");
}

} // Enable KoN Taunts

function TargetFlag(%team)
{
	if(%team = "Friendly")
	{
		%location = $Enemy;
		if(%location == "home" || %location == "dropped")
		{
			return;
		}
		TargetClientByName(%location, "Help: " @ %location @ "~wescfr");
		remoteBP(2048, "<jc>Help: <f1>" @ %location @ "<f0>!", 2);
	}
	if(%team = "Enemy")
	{
		%location = $Friendly;
		if(%location == "home" || %location == "dropped")
		{
			return;
		}
		TargetClientByName(%location, "Kill: " @ %location @ "~wattway");
	}
}

function targetClientByName(%name, %msg)
{
	%clientId = getClientByName(%name);
	remoteEval(2048, "IssueTargCommand", 0, %msg, %clientID - 2048, getManagerId());
}