//-------------------------------------------------------------------------//
// Nee Chat!								   //
// Version:	1.0							   //
// Category:	This Script is my version of Presto's Menu.cs, but it	   //
//		is not as comfortable as his one.			   //
// Credits:	|HH|BigBunny, Presto					   //
//-------------------------------------------------------------------------//
// Here are the functions you can add in this file. But only do this if you
// really know something about scripting.
//
//		SetPlayChatMenu(%heading);
//			If you want to change this function it would look
//			like:
//			  SetPlayChatMenu("bBackpacks");
//			the first letter stands for the key you must push
//			to open this menu. The Rest is the Information
//			about this Menu.
//		AddPlayTeamChat(%text, %msg, %sound);
//			This function can be used to add Team Chat Messages
//			to your Menu. It should look like this:
//			  AddPlayTeamChat("aAttack!", "Attack", attack);
//			The first letter stands for the key you must push
//			to say this text, The Rest is the Information about
//			the Text you will say. the %msg variable stands for
//			the message you say in the chatmenu and %sound stands
//			for the WAV file which is played with the activation.
//		AddPlayChat(%text, %msg, %sound);
//			This cuntion is similar to the AddPlayTeamChat
//			function, but it is Public, not Team Chat.
//		AddDropMenu(%text, %item);
//			This function can be used to drop items from within
//			a menu. Add the %text variable as in all examples
//			above and use the %item variable to define the
//			item to be dropped by menu.
//---------------------------------------------------------------------------

newObject(PlayChatMenu, ChatMenu, "Nee! Pack Soundsystem:");

function addDropMenu(%text, %desc)
{
	if(%item = "")
	{
		return;
	}
	if($curPlayChatMenu != "")
   	{
		%text = $curPlayChatMenu @ "\\" @ %text;
	}
	addCMCommand(PlayChatMenu, %text, drop, %desc);
}

// Nee! Pack Soundsystem Chat menu:

if(isFile("base\\voices\\KoNTaunts.vol"))
{
	$Enable[KoNTaunts] = true;
}

setPlayChatMenu("vOffense");
		addPlayTeamChat("aAttack!","Attack!", attack);
		addPlayTeamChat("wWait for signal", "Wait for my signal to attack.", waitsig);
		addPlayTeamChat("cCease fire", "Cease fire!", cease);
		addPlayTeamChat("mMove out", "Move out.", moveout);
		addPlayTeamChat("rRetreat", "Retreat!", retreat);
		addPlayTeamChat("hHit deck", "Hit the deck!", hitdeck);
		addPlayTeamChat("eRegroup", "Regroup.", regroup);
		addPlayTeamChat("vCover me", "Cover me!", coverme);
		addPlayTeamChat("gGoing offense", "Going offense.", ono);
		addPlayTeamChat("zAPC ready", "APC ready to go... waiting for passengers.", waitpas);
		addPlayTeamChat("bAttack base!", "Attack the enemy base!", attack);
		addPlayTeamChat("fAttack flag!", "Attack the enemy flag!", attack);
		addPlayTeamChat("tAttack turrets!", "Attack enemy turrets!", destur);
		addPlayTeamChat("oGet Objective!", "Get the enemy objective!", getobj);
		addPlayTeamChat("dBase destroyed!", "Enemy base destroyed!", gendes);
		addPlayTeamChat("uCapture Objective!", "Capture the Objective!", capobj);

setPlayChatMenu("tTarget");
		addPlayTeamChat("aTarget acquired", "Target Acquired", tgtacq);
		addPlayTeamChat("fFire on my target", "Fire on my target", firetgt);
		addPlayTeamChat("nTarget needed", "I need a target.", needtgt);
		addPlayTeamChat("oTarget out of range", "Target out of range.", tgtout);
		addPlayTeamChat("dDestroy Enemy Generator", "Destroy the enemy genarator.", desgen);
		addPlayTeamChat("eEnemy Generator Destroyed", "Enemy generator destroyed.", gendes);
		addPlayTeamChat("tDestroy Enemy Turret", "Destroy enemy turret.", destur);
		addPlayTeamChat("sEnemy Turret Destroyed", "Enemy turret destroyed.", turdes);
		addPlayTeamChat("rEnemy RT destroyed", "Enemy Rocket Turret destroyed.", turdes);
		addPlayTeamChat("wIndoor Turret destroyed", "Enemy Indoor Turret destroyed.", turdes);
		addPlayTeamChat("qRemote Turret destroyed", "Enemy Remote Turret destroyed.", turdes);

setPlayChatMenu("dDefense");
		addPlayTeamChat("iIncoming Enemies", "Incoming enemies!", incom2);
		addPlayTeamChat("aAttacked", "We are being attacked.", basatt);
		addPlayTeamChat("eEnemy is attacking base", "The enemy is attacking our base.", basundr);
		addPlayTeamChat("nNeed more defense", "We need more defense.", needdef);
		addPlayTeamChat("bDefend our base", "Defend our base.", defbase);
		addPlayTeamChat("dDefending base", "Defending our base.", defend);
		addPlayTeamChat("tBase Taken", "Base is taken.", basetkn);
		addPlayTeamChat("cBase Clear", "Base is secured.", bsclr2);
		addPlayTeamChat("qIs Base Clear?", "Is our base clear?", isbsclr);
		addPlayTeamChat("mClear mines", "Clear mines from our objective", clrobj);
		addPlayTeamChat("oObjective mined", "Our Objective is mined", mineobj);
		addPlayTeamChat("fDefending Flag", "Defending our flag", defend);
		addPlayTeamChat("hIncoming Heavies", "Incoming Heavies!", incom2);

setPlayChatMenu("fFlag");
		addPlayTeamChat("gFlag gone", "Our flag is not in the base!", flgtkn1);
		addPlayTeamChat("eEnemy has flag", "The enemy has our flag!", flgtkm2);
		addPlayTeamChat("hHave enemy flag", "I have the enemy flag, cover me!", haveflg);
		addPlayTeamChat("sFlag secure", "Our flag is secure.", flaghm);
		addPlayTeamChat("rReturn our flag", "Return our flag to base.", retflag);
		addPlayTeamChat("fGet enemy flag", "Get the enemy flag.", geteflg);
		addPlayTeamChat("mFlag mined", "Our flag is mined.", flgmine);
		addPlayTeamChat("cClear mines", "Clear the mines from our flag.", clrflg);
		addPlayTeamChat("dMines cleared", "Mines have been cleared.", mineclr);
		addPlayTeamChat("aFlag dropped", "I dropped the enemy flag, get it now", geteflg);
		addPlayTeamChat("wDetach Capper", "Detach me! Get the flag!", haveflg);

setPlayChatMenu("rNeed");
		addPlayTeamChat("rNeed Repairs", "Need repairs.", needrep);
		addPlayTeamChat("aNeed APC Pickup", "I need an APC pickup.", needpku);
		addPlayTeamChat("eNeed Escort", "I need an escort back to base.", needesc);
		addPlayTeamChat("tNeed Ammo", "Can anyone bring me some ammo?", needamo);
		addPlayTeamChat("mNeed Mortar Ammo", "Can anyone bring me some Mortar ammo?", needamo);
		addPlayTeamChat("nNeed Mines", "Can anyone bring me some mines?", needamo);

setPlayChatMenu("eTeam");
		addPlayTeamChat("aNo Problem", "No Problem.", noprob);				
		addPlayTeamChat("bBelay order", "Belay order.", belay);
		addPlayTeamChat("cOrder cancelled", "Order cancelled!", ordcan);
		addPlayTeamChat("pProceed ahead", "Proceed ahead!", proceed);		
		addPlayTeamChat("gRegroup", "Regroup!", regroup);
		addPlayTeamChat("rReady", "Ready, I'm in position!", ready);
		addPlayTeamChat("jWait", "Wait!", wait1);
		addPlayTeamChat("kWaiting", "Waiting..", wait2);
		addPlayTeamChat("eHelp!!", "Help!!", help);																			
		addPlayTeamChat("iI dont know", "I don't know", dontkno);
		addPlayTeamChat("nNo", "No", no);
		addPlayTeamChat("yYes", "Yes", yes);						
		addPlayTeamChat("sSorry", "Sorry", sorry);
		addPlayTeamChat("tThanks", "Thanks", thanks);						
		addPlayTeamChat("hHurry up with the station!", "Hurry up with the station!", hurystn);
		addPlayTeamChat("wWatch where you're shooting", "Watch where your shooting", wshoot3);
		addPlayTeamChat("xYou Idiot!", "You Idiot!", dsgst2);

setPlayChatMenu("gGlobal");
		addPlayChat("aNo problem.", "No problem.", noprob);
		addPlayChat("cAh, Crap!", "Ah, Crap!", color7);
		addPlayChat("dI don't know.", "I don't know.", dontkno);
		addPlayChat("eDuh!", "Duh!", dsgst1);
		addPlayChat("fWait!", "Wait!", wait1);
		addPlayChat("gWaiting..", "Waiting..", wait2);
		addPlayChat("iSigh..", "Sigh..", dsgst5);
		addPlayChat("jArgh!", "Argh!", dsgst4);
		addPlayChat("kThis sucks!", "This sucks!", dsgst5);
		addPlayChat("lHey!!", "Hey!", wshoot1);
		addPlayChat("mHmmm..", "Hmmm..", color3);
		addPlayChat("nNo", "No", no);
		addPlayChat("oOops!", "Oops!", oops2);
		addPlayChat("pAll-right!", "All-right!", cheer3);
		addPlayChat("qDamnit", "Damnit!", color6);
		addPlayChat("rReady!", "Ready!", ready);
		addPlayChat("sSorry!", "Sorry!", sorry);
		addPlayChat("tThanks!", "Thanks!", thanks);
		addPlayChat("uShazbot!", "Shazbot!", color2);
		addPlayChat("wWoo-Hoo!!", "Woo-Hoo!!", cheer2);
		addPlayChat("xYou Idiot!", "You Idiot!", dsgst2);
		addPlayChat("yYes", "Yes", yes);
		addPlayChat("zDoh", "Doh!", oops1);
		addPlayChat("hHi!", "Hi!", hello);
		addPlayChat("bBye", "Bye!", bye);

setPlayChatMenu("aAnimations");
		addPlayAnim("oOver here", 0, ovrhere);
		addPlayAnim("dMove out of way", 1, outway);
		addPlayAnim("rRetreat", 2, retreat);
		addPlayAnim("sStop", 3, dsgst4);
		addPlayAnim("fSalute", 4, yes);
		addPlayAnim("zKneel Pose", 10);
		addPlayAnim("xStand Pose", 11);
		addPlayAnim("qCelebrate 1", 5, cheer1);
		addPlayAnim("eCelebrate 2", 6, cheer2);
		addPlayAnim("wCelebrate 3", 7, cheer3);
		addPlayAnim("vTaunt 1 - how'd that feel?", 8, taunt10);
		addPlayAnim("gTaunt 2 - Come get some", 9, taunt4);
		addPlayAnim("hWave - Hi", 12, hello);
		addPlayAnim("bWave - Bye", 12, bye);

setPlayChatMenu("zCommand Response");
		addPlayCMDResponse("aAcknowledged", 1, "Command acknowledged", "acknow");
		addPlayCMDResponse("zCompleted", 0, "Objective complete", "objcomp");
		addPlayCMDResponse("uUnable to complete", 0, "Unable to complete objective", "objxcmp");

if($Enable[KoNTaunts])
{

setPlayChatMenu("1Knights of Nee Taunts");
		addPlayChat("1Bite legs off", "I'll bite your legs off!", bitelegs);
		addPlayChat("2I fart...", "I fart in your general direction.", fart);
		addPlayChat("3Silly sod", "You silly sod!!!", sod);
		addPlayChat("4Bleed on me?", "What're you going to do - bleed on me?!", bleed);
		addPlayChat("5Scratch", "Tis but a scratch.", scratch);
		addPlayChat("62nd Taunt", "Now go away or I will taunt you a second time!", taunt);
		addPlayChat("7Invincible", "I'm INVINCIBLE!!", knight);
		addPlayChat("8None shall pass", "None shall pass!", nonepass);
		addPlayChat("9Ecky Ecky", "Ecky, ecky, ecky, ecky putang zupoing browy ni!", icky);
		addPlayChat("0Bring out your dead", "Bring Out your Dead!", dead);
		addPlayChat("qGo away", "Go Away!", goaway);
		addPlayChat("wHandgrenade", "Oh Lord, bless this thy handgrenade.", grenade);
		addPlayChat("eI feel happy", "I feel Happy!", happy);
		addPlayChat("rBloody hell", "Oh bloody hell!", hell);
		addPlayChat("tLucky bastard", "You lucky, lucky bastard!", lucky);
		addPlayChat("yPointy teeth", "Death awaits you with nasty big pointy teeth!", pointy);
		addPlayChat("uStupid bastard", "You stupid bastard! ;)", stupid);
		addPlayChat("iWoman?", "Are there any WOMEN here today?", women);
		addPlayChat("oBiscuit", "Alright, alright - we'll kill him first and then have tea and biscuits.", biscuit);
		addPlayChat("pIntermission", "<-- intermission -->", intrmsn);
		addPlayChat("aDamn Damn", "Oh damn, damn, damn!", damndamn);
		addPlayChat("sEccentric Performance", "What an eccentric performance...", ecentric);
		addPlayChat("dDynamite Rabbit", "Better not risk another frontal assault, that rabbit's dynamite!", frontal);
		addPlayChat("fBefore i get killed", "I'd like to leave sir, before I get killed.", getkilled);
		addPlayChat("gBe crucified", "Go ahead, be crucified! See if I care.", goahead);
		addPlayChat("hHamster", "Your mother was a hamster and your father smelt of elderberries!", hamster);
		addPlayChat("jHelp!", "Help, help! I'm being repressed!", help);
		addPlayChat("kCall it draw", "Alright. We'll call it a draw.", itsadraw);
		addPlayChat("lJesus", "Jesus Christ!", jc);
		addPlayChat("zLeave Army", "I'd like to leave the army please sir, it's dangerous.", leavarmy);
		addPlayChat("xYoure a loony", "You're a looney.", looney);
		addPlayChat("cRunning away", "Oh I see. Running away eh?", ohisee);
		addPlayChat("vSucide squad", "Suicide squad...Attack!", quad);
		addPlayChat("bRun away", "Run away, run away!", retreat);
		addPlayChat("nShrubbery", "A shrubbery!", shrub);
		addPlayChat("mGood spanking", "You must give us all a good spanking!", spank);
		addPlayChat("[Waste of time", "This is a complete waste of time.", waste);
		addPlayChat("]Waste of human life", "It's such a senseless waste of human life isn't it?", wastlife);
}
	
SetPlayChatMenu("bDrop: Weapons");
		addDropMenu("1Blaster", "Blaster");
		addDropMenu("2Plasma Gun", "Plasma Gun");
		addDropMenu("3Chaingun", "Chaingun");
		addDropMenu("4Disc Launcher", "Disc Launcher");
		addDropMenu("5Grenade Launcher", "Grenade Launcher");
		addDropMenu("6Laser Rifle", "Laser Rifle");
		addDropMenu("7ELF Gun", "ELF Gun");
		addDropMenu("8Mortar", "Mortar");
		addDropMenu("9Targeting Laser", "Targeting Laser");

SetPlayChatMenu("nDrop: Ammo");
		addDropMenu("1Plasma", "Plasma Bolt");
		addDropMenu("2Grenade", "Grenade Ammo");
		addDropMenu("3Mortar", "Mortar Ammo");
		addDropMenu("4Disc", "Disc");
		addDropMenu("5Bullet", "Bullet");
		addDropMenu("6Handgrenade", "Grenade");
		addDropMenu("7Mine", "Mine");

SetPlayChatMenu("mDrop: Misc");
		addDropMenu("1Backpack", "Backpack");
		addDropMenu("2Flag", "Flag");
		addDropMenu("3Repair Kit", "Repair Kit");
		addDropMenu("4Current Weapon", "Weapon");
		addDropMenu("5Current Ammo", "Ammo");