// -=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=- //
// Miscellaneous Support Scripts					   //
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=- //
// Included Scripts: Schedule.cs, HUD::Destroy(), Drop, Debug		   //
// Credits:	Presto, Presto and Presto, Mental Trousers, Dynamix Dev	   //
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=- //

// Directly from Presto's Schedule.cs
function Schedule::Add(%eval, %time, %tag)
{
	if(%tag == "")
		%tag = %eval;
	$Schedule::ID[%tag]++;
	$Schedule::eval[%tag] = %eval;
	schedule("Schedule::Exec(\""@escapestring(%tag)@"\", "@$Schedule::ID[%tag]@");", %time);
}

function Schedule::Exec(%tag, %id)
{
	if($Schedule::ID[%tag] != %id)
		return;
	%eval = $Schedule::eval[%tag];
	Schedule::Cancel(%tag);
	eval(%eval);
}

function Schedule::Cancel(%tag)
{
	$Schedule::ID[%tag]++;
	$Schedule::eval[%tag] = "";
}
// Destroy HUD
// from Mental Trouser's Website, also in Viking Pack
function HUD::Destroy(%hudstring)
{
	%ngs = nameToId(NamedGuiSet);
	%len = Group::objectCount(%ngs);
	for(%i = 0; %i < %len; %i++)
	{
		%obj = Group::getObject(%ngs, %i);
		%objectName=Object::getName(%obj);
  
  		if(String::findSubStr(%objectname, %hudstring) != -1 )
			deleteObject(%obj);
	}
	return;
}
// Drop function from client.cs
function drop(%desc)
{
	%type = getItemType(%desc);
	if (%type != -1) {
		remoteEval(2048,dropItem,%type);
		%count = getItemCount(%desc);
		if(%count > 0)
		  remoteBP(2048, "<jc>You dropped item: <f1>" @ %desc, 2);
	}
	else {
		echo("Unknown item \"" @ %desc @ "\"");
	}
}