//-------------------------------------------------------------------------//
// Nee! Pack								   //
// Version: 1.0								   //
// [ autoexec.cs ]							   //
// WARNING: Don't execute any files here. Name your			   //
// script files *.nee.cs and they will be executed automatically.	   //
//-------------------------------------------------------------------------//

if(!$dedicated)
{

function NeePack::Init()
{
	$NeePack::Version = "1.0 beta 3";
	Echo("-=-=-=-=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=-=-");
	Echo("Initializing Nee! Pack......");
	Echo("Version: " @ $NeePack::Version);
	Echo("Flames, Suggestions and Bug Report to:");
	Echo("Grinder.tribes@gmx.de");
	Echo("Website: http://www.starsiege-tribes.de/grinder");
	Echo("-=-=-=-=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=-=-");
	Echo("Autoloading Nee! Pack files");
	$ConsoleWorld::DefaultSearchPath = "config";
	exec("NeeEnable.cs");
	for(%file = File::FindFirst("*.nee.cs"); %file != ""; %file = File::FindNext("*.nee.cs"))
	{
		exec(%file);
	}
	exec("neeprefs\\misc.pref.cs");
	$pref::skipintro = true; // anybody to see the intro?
}

// General Code from Presto's Install.cs
$Nee::ScreenSize["320x240(V)"] = "320 240";
$Nee::ScreenSize["400x300(V)"] = "400 300";
$Nee::ScreenSize["480x360(V)"] = "480 360";
$Nee::ScreenSize["512x384"] = "512 384";
$Nee::ScreenSize["640x400"] = "640 400";
$Nee::ScreenSize["640x480"] = "640 480";
$Nee::ScreenSize["800x600"] = "800 600";
$Nee::ScreenSize["1024x768"] = "1024 768";

function Nee::ScreenSize()
{
	%res = $pref::videoFullScreenRes;
	if ($pref::VideoFullScreen)
	{
		%posRes = $Nee::ScreenSize[%res];
		if (%posRes != "")
			return %posRes;
	}
	return $Nee::screenSize["640x480"];
}

function NeePack::InstallStatus()
{
	%text =	" Nee!Favs <jl><f1>";
	if($Enable[NeeFa])
	{
		%text = %text @ "enabled<f0>\n<jl>";
	}
	else
	{
		%text = %text @ "disabled<f0>\n<jl>";
	}
	%text = %text @ " FlagTracker <jl><f1>";
	if($Enable[FlagT])
	{
		%text = %text @ "enabled<f0>\n<jl>";
	}
	else
	{
		%text = %text @ "disabled<f0>\n<jl>";
	}
	%text = %text @ " Dropper <jl><f1>";
	if($Enable[Dropp])
	{
		%text = %text @ "enabled<f0>\n<jl>";
	}
	else
	{
		%text = %text @ "disabled<f0>\n<jl>";
	}
	%text = %text @ " Compass <jl><f1>";
	if($Enable[Retic])
	{
		%text = %text @ "enabled<f0>\n<jl>";
	}
	else
	{
		%text = %text @ "disabled<f0>\n<jl>";
	}
	%text = %text @ " DemoPlay <jl><f1>";
	if($enable[DemoP])
	{
		%text = %text @ "enabled<f0>\n<jl>";
	}
	else
	{
		%text = %text @ "disabled<f0>\n<jl>";
	}
	$NeePack::Status = %text;
}

function MainMenuGui::onOpen()
{
	%screenSize = Nee::ScreenSize();
	%width = getWord(%screenSize,0);
	%height = getWord(%screenSize, 1);
	%boxHeight = 125;
	if (!isObject(NeeStatus))
	{
		newObject(NeeStatus, FearGui::FearGuiBox, 50,%height-45 - %boxHeight, 200,%boxHeight);
	}
	if (!isObject(NeeStatusText))
	{
		newObject(NeeStatusText, FearGuiFormattedText, 1,0,190,400);
	}
	NeePack::InstallStatus();
	AddToSet(NeeStatus, NeeStatusText);
	AddToSet(MainMenuGui, NeeStatus);
	$NeePack::Status = $NeePack::Status @ "\n Flames and Bug Report to:\n <f1>Grinder.tribes@gmx.de";
	Control::SetValue(NeeStatusText, " <f2>Nee! Pack<f0>  Version: <f1>" @ $NeePack::version @ " <f0>\n" @ $NeePack::Status);
}

NeePack::Init();
Echo("Nee Pack has been successfully loaded");
Echo("-=-=-=-=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=-=--=-=-=-=-=-=-=-");

} // dedicated server check